<?php function dike_init($author_slug,$config,$products){$author_slug=sanitize_title((string)$author_slug);if(empty($author_slug)||empty($config)||!is_array($config)||empty($products)||!is_array($products)){return new WP_Error('dike_bad_init',sprintf('Dike WordPress Dashboard - Author "%s" - bad initilization',$author_slug));}$config_indexes=array('menu_label','author_name','logo_url','lic_check_endpoint_url','updates_endpoint_url','no_support_no_upd_faq_url','custom_head_code','custom_footer_code','pre_products_txt','how_to_get_token_txt',);foreach($config_indexes as $ci){if(!isset($config[$ci])){return new WP_Error('dike_config_key_missing',sprintf('Dike WordPress Dashboard - Author "%s" - "%s" configuration key missing',$author_slug,$ci));}}if(!isset($GLOBALS['dike_authors'])){$GLOBALS['dike_authors']=array();$GLOBALS['dike_products']=array();}$GLOBALS['dike_authors'][$author_slug]=$config;$prod_ids=array();$prod_indexes=array('id','name','slug','prod_pag_link','buy_prod_link','doc_link','changelog_link','has_trial','logo_url');foreach($products as $prod_path=>$pdata){$skip=false;foreach($prod_indexes as $pi){if(!isset($config[$ci])){trigger_error(sprintf('Dike WordPress Dashboard - "%s" - "%s" configuration key missing',$prod_path,$pi));$skip=true;break;}}if($skip){continue;}$pdata['id']=(int)$pdata['id'];$pdata['author']=$author_slug;if(in_array($pdata['id'],$prod_ids)){trigger_error(sprintf('Dike WordPress Dashboard - Author "%s" - product ID %s already exists',$author_slug,$pdata['id']));continue;}$prod_ids[]=$pdata['id'];$pdata['slug']=$author_slug.'-'.$pdata['slug'];if(!isset($GLOBALS['dike_products'][$author_slug])){$GLOBALS['dike_products'][$author_slug]=array();}$GLOBALS['dike_products'][$author_slug][$prod_path]=$pdata;}}function dike_lc($author,$slug,$js_redirect=false){return dike_licenses::plc($author,$slug,$js_redirect);}function dike_dashboard_message($author){global $dike_authors;return '';$transient_name='dike_'.sanitize_title($author).'_dashboard_mess';$data=get_transient($transient_name);if(!$data||1){$action='dashboard_message';$params=array('auth_key'=>'customer.website','action'=>$action,'username'=>$author,);$endpoint=$dike_authors[$author]['lic_check_endpoint_url'];if(!wp_http_supports(array('ssl'))){$endpoint=set_url_scheme($endpoint,'http');}$params=(array)apply_filters('dike_wp_remote_post_params',$params,$author,$action);add_filter('https_ssl_verify','__return_false',99999999);$data=@wp_remote_post($endpoint,array('timeout'=>5,'redirection'=>1,'body'=>json_encode($params),'sslverify'=>false,'reject_unsafe_urls'=>false,));if(is_wp_error($data)||wp_remote_retrieve_response_code($data)!=200){return '';}else{$data=json_decode(wp_remote_retrieve_body($data),true);set_transient($transient_name,$data,60*30);}}$indexes=array('txt','type','valid_from','valid_until','dismissible');foreach($indexes as $i){if(!isset($data[$i])){return '';}}$notice_id=md5(json_encode($data));$dismissible_class=($data['dismissible'])?'is-dismissible':'';if($data['dismissible']&&isset($_COOKIE['dike_notice_'.$notice_id.'_dismissed'])){return '';}if(gmdate('U')<$data['valid_from']||gmdate('U')>$data['valid_until']){return '';}$code='
    <div class="dike_author_notice notice notice-'.$data['type'].' '.$dismissible_class.'" data-notice-id="'.$notice_id.'">
        <div>'.$data['txt'].'</div>
    </div>';return $code;}function dike_output_enabled_prod_block($prod_path,$pdata,$licenses){$has_prod_lic=(isset($licenses[(int)$pdata['id']]))?true:false;$ren_supp_link=(isset($pdata['ren_supp_link'])&&!empty($pdata['ren_supp_link']))?$pdata['ren_supp_link']:$pdata['prod_pag_link']; ?>
    
    <li class="dike_prod" data-prod-id="<?php echo esc_attr($pdata['id']) ?>" data-prod-slug="<?php echo esc_attr($pdata['slug']) ?>" data-prod-changelog="<?php echo esc_attr($pdata['changelog_link']) ?>">
        <div class="dike_prod_firstblock">
            <span>
                <img src="<?php echo esc_attr($pdata['logo_url']) ?>" alt="<?php echo esc_attr($pdata['name']) ?>" />
            </span>

            <div>
                <h4>
                    <?php echo $pdata['name'];if(!$has_prod_lic){echo '<span href="javascript:void(0)" data-tooltip="Product locked. Validate the license domain token to unlock" class="dashicons dashicons-warning dike_prod_not_validated_warn dike_tooltip"></span>';}if(!empty($pdata['changelog_link'])){echo '<a href="javascript:void(0)" class="dashicons dashicons-editor-ul dike_changelog_trigger dike_tooltip" data-tooltip="view changelog"></a>';}if(!empty($pdata['doc_link'])){echo '<a href="'.esc_attr($pdata['doc_link']).'" target="_blank" class="dashicons dashicons-flag dike_doc_link dike_tooltip" data-tooltip="view documentation"></a>';}echo '<a href="'.esc_attr($pdata['buy_prod_link']).'" target="_blank" class="dashicons dashicons-cart dike_shop_link dike_tooltip" data-tooltip="need a new license?"></a>'; ?>
                </h4>

                <?php if(!dike_licenses::supports_lc_dashboard($prod_path,$GLOBALS['dike_dashboad_author'])): ?>
                    <span class="dike_update_to_use_warn">Please update the product to the latest version in order to integrate it here</span>

                <?php else: ?>

                    <?php if($has_prod_lic): ?>
                        <form method="post" class="dike_inserted_token_form form-wrap">
                            <fieldset>
                                <input type="text" name="dike_inserted_token" value="<?php echo $licenses[$pdata['id']]['tok'] ?>" disabled="disabled" />
                                <input type="button" name="dike_change_token_btn" value="Change" class="button-secondary" />
                            </fieldset>
                        </form>   
                    <?php endif; ?>

                    <form method="post" class="dike_insert_token_form form-wrap <?php if(isset($licenses[$pdata['id']]))echo 'dike_displaynone' ?>">
                        <fieldset>
                            <input type="text" name="dike_prod_token" value="" placeholder="activation token" autocomplete="off" maxlength="32" required="required" />
                            <input type="button" name="dike_prod_activation_btn" value="Validate" class="button-secondary" />

                            <input type="text" name="dike_purch_code" value="" placeholder="purchase code" autocomplete="off" maxlength="36" class="dike_displaynone" />
                            <input type="text" name="dike_username" value="" placeholder="envato username" autocomplete="off" maxlength="125" class="dike_displaynone" />
                            <a href="javascript:void(0)" class="dike_offline_valid">Offline validation</a>
                        </fieldset>    
                    </form>

                    <?php if(!$has_prod_lic){echo '<a href="javascript:void(0)" class="dike_how_get_token">How to get the token?</a>';}endif; ?>
            </div>
        </div>

        <?php if(dike_licenses::supports_lc_dashboard($prod_path,$GLOBALS['dike_dashboad_author'])&&$has_prod_lic): ?>
            <div class="dike_lic_details">
                <p>
                    <i class="dike_tooltip" data-tooltip="Envato Username">
                        <span class="dashicons dashicons-admin-users"></span> <?php echo $licenses[$pdata['id']]['user'] ?>
                    </i>
                    <i>
                        <span class="dashicons dashicons-awards"></span> <?php echo ucfirst($licenses[$pdata['id']]['type']) ?> license
                        <?php if($licenses[$pdata['id']]['expir']){echo '('.dike_licenses::human_lic_expir_remaining_time($licenses[$pdata['id']]['expir']).')';} ?>
                    </i>
                </p>

                <?php if(in_array($licenses[$pdata['id']]['type'],array('production','staging'))): ?>
                <p>
                    <label><?php echo dike_licenses::human_support_remaining_time($licenses[$pdata['id']]['set'],true) ?></label>
                    <a href="<?php echo esc_attr($ren_supp_link) ?>" target="_blank">
                        <button type="button" name="dike_extend_support_btn" class="button-secondary">
                            <span class="dashicons dashicons-cart"></span>
                            <span>Extend it</span> 
                        </button>    
                    </a>
                </p>
                <?php endif; ?>

            </div>
        <?php endif; ?>

    </li>
    <?php }function dike_output_missing_prod_block($author,$pdata){ ?>
    <li class="dike_prod" data-prod-id="<?php echo (int)$pdata['id'] ?>">
        <div class="dike_prod_firstblock">
            <span>
                <img src="<?php echo esc_attr($pdata['logo_url']) ?>" alt="<?php echo esc_attr($pdata['name']) ?>" />
            </span>

            <div class="dike_not_own_btn">
                <h4><?php echo $pdata['name'] ?></h4>
                <a href="<?php echo esc_attr($pdata['prod_pag_link']) ?>" target="_blank">
                    <button type="button" name="dike_knowmore_btn" class="button-secondary">
                        <span class="dashicons dashicons-share-alt"></span>
                        <span>Know more</span>         
                    </button>    
                </a>

                <?php if($pdata['has_trial']): ?>
                    <a href="https://<?php echo $author  ?>.dikelicensing.com/trial-license-request/?prod=<?php echo (int)$pdata['id'].'&domain='.urlencode(dike_licenses::ignore_www($_SERVER['HTTP_HOST'])).'&disabled=domain' ?>" target="_blank">
                        <button type="button" name="dike_gettrial_btn" class="button-secondary">
                            <span class="dashicons dashicons-tickets"></span>
                            <span>Request a trial</span>         
                        </button>    
                    </a>
                <?php endif; ?>
            </div>
        </div>
    </li>
    <?php }function dike_menu(){global $dike_authors,$submenu;foreach((array)$dike_authors as $author_slug=>$config){if(!isset($GLOBALS['dike_menu_setup_config'])){$GLOBALS['dike_menu_setup_config']=array();}$GLOBALS['dike_menu_setup_config'][$author_slug]=$config['menu_label'];$no_menu=apply_filters('dike_skip_'.$author_slug.'_menu',false);if($no_menu){continue;}add_submenu_page('index.php',$config['menu_label'],$config['menu_label'],'manage_options','dike_wpd','dike_wpd');}add_action('admin_footer',function(){ ?>
        <script type="text/javascript">
        (function() { 
            "use strict";   

            let menus = JSON.parse(`<?php echo json_encode($GLOBALS['dike_menu_setup_config']) ?>`);
            
            document.querySelectorAll('#menu-dashboard .wp-submenu a').forEach(function($a) {
                let link = $a.getAttribute('href'),
                    txt  = $a.innerText;
                
                if(link != 'index.php?page=dike_wpd') {
                    return;    
                }
                
                Object.keys(menus).some((author_slug) => {
                    const label = menus[ author_slug ];   
                    
                    if(label == txt) {
                        $a.setAttribute('href', 'index.php?page=dike_wpd&author='+ author_slug);    
                        delete menus[ author_slug ];
                    }
                });
            });
        })();    
        </script>
        <?php });}function dike_wpd(){include_once(__DIR__.'/licenses.php');include_once(__DIR__.'/dashboard.php');}function dike_require_author(){global $current_screen,$dike_authors;if(!is_admin()){return true;}if(property_exists($current_screen,'base')&&$current_screen->base=='dashboard_page_dike_wpd'){if(!isset($_GET['author'])){wp_safe_redirect(admin_url());exit;}$author=$_GET['author'];if(isset($dike_authors[$author])&&$dike_authors[$author]['custom_head_code']){add_action('admin_head',function(){echo $GLOBALS['dike_authors'][$_GET['author']]['custom_head_code'];});}if(isset($dike_authors[$author])&&$dike_authors[$author]['custom_footer_code']){add_action('admin_footer',function(){echo $GLOBALS['dike_authors'][$_GET['author']]['custom_footer_code'];});}}}add_action('current_screen','dike_require_author');add_action('admin_enqueue_scripts',function(){global $current_screen;if($current_screen->base=='dashboard_page_dike_wpd'||$current_screen->base=='plugins'||$current_screen->base=='themes'){wp_enqueue_style('dike_admin',$GLOBALS['dike_baseurl'].'/assets/css.min.css',100,$GLOBALS['dike_init']);wp_enqueue_script('lc-wp-popup-message',$GLOBALS['dike_baseurl'].'/assets/lc_wp_popup_message.min.js',200,'1.0');}},99999);add_action('admin_footer',function(){global $current_screen;if($current_screen->base!='plugins'){return false;} ?>
    <script type="text/javascript">
    (function() { 
        "use strict";   

        document.querySelectorAll('.lcwpau_wizard_btn').forEach(function($btn) {
            $btn.setAttribute('href', "<?php echo admin_url() ?>index.php?page=dike_wpd");
            $btn.classList.remove('thickbox');
        });
    })();    
    </script>
    <?php });add_action('admin_init',function(){$versions_opt_name='dike_activation_redirect_helper';if(!current_user_can('manage_options')||(strpos($_SERVER["REQUEST_URI"],'/plugins.php')===false&&strpos($_SERVER["REQUEST_URI"],'/themes.php')===false)){return false;}$stored_versions=get_site_option($versions_opt_name);$to_save=array();$has_changelog=array();foreach($GLOBALS['dike_products']as $author=>$products){foreach($products as $path=>$pdata){$subj_data=false;if(!dike_licenses::prod_is_theme($path)&&strpos($_SERVER["REQUEST_URI"],'/plugins.php')!==false){if(!is_plugin_active($path)){continue;}$subj_data=get_plugin_data(WP_PLUGIN_DIR.'/'.$path);}elseif(dike_licenses::prod_is_theme($path)&&strpos($_SERVER["REQUEST_URI"],'/themes.php')!==false){if(get_template()!=$path){continue;}$subj_data=wp_get_theme($path);}if(!$subj_data){continue;}$to_save[$pdata['slug']]=$subj_data['Version'];$has_changelog[$pdata['slug']]=(empty($pdata['changelog_link']))?false:true;}}if($stored_versions==$to_save){return true;}update_site_option($versions_opt_name,$to_save);foreach($to_save as $slug=>$new_version){$arr=explode('-',$slug);$author=$arr[0];$no_redirect=($has_changelog[$slug])?false:true;$no_redirect=apply_filters('dike_skip_'.$author.'_redirect',$no_redirect,$slug);if($no_redirect){continue;}if(empty($stored_versions)||!isset($stored_versions[$slug])||(isset($stored_versions[$slug])&&$stored_versions[$slug]!=$new_version)){$url=admin_url().'index.php?page=dike_wpd&author='.$author;if(!isset($stored_versions[$slug])){$url.='&prod_welcome='.$slug;}else if(!empty($stored_versions)&&isset($stored_versions[$slug])){$url.='&prod_updated&prod_cl='.$slug;}wp_safe_redirect($url);break;}}});add_action('init',function(){global $dike_authors;if(!class_exists('dike_licenses')||!is_array($dike_authors)){return false;}$an_author=array_keys($dike_authors)[0];$lic_class=new dike_licenses($an_author);$lic_class->get_licenses(false);},PHP_INT_MAX);